# Prerequisite API's

[comment]: # (#######################################################################################################)
[comment]: # (# 								                    OAuth2 Token Generation API											                #)
[comment]: # (#######################################################################################################)

## OAuth2 Token Generation API

> If login authentication `success` the above command will return a JSON structure like this along with `access_token`

```json
{
  "access_token": "QzQ7wTld-eTNmp_kHvuocYQ9IMAV11g3IuzL60uT_iegxHgn2fm6VKUMQnFq700dsalNekIawBf5S_nHOiaA1dNZ6tCDHg7jN4PEcIvOpN2hw5Li0VAfqxkpU3cXoLdcMTgV4h1vE1NwocoxTzr27BkQlGFtto2O_6Dq_zzEyIGL6Jn0BDUd3d5mnvwdqOBcnqu0_hZieANA0i1GP-WbpA",
  "token_type": "bearer",
  "expires_in": 14399,
  "userName": "abc",
  ".issued": "Fri, 06 Sep 2019 05:01:29 GMT",
  ".expires": "Fri, 06 Sep 2019 09:01:29 GMT"
}
```

> If login authentication `failed` the above command will return a JSON structure like this along with`error` and `error_description`

```json
{
  "error": "invalid_grant",
  "error_description": "The user name or password is incorrect."
}
```

**Description**

The user needs to authenticate in order to make requests to any API. This API returns a `Authorization Code` which is further a prerequsite of creating a JobStatus ID and API's.

**HTTP Request Type**

<font color="#FFFFFF" style="background-color: #FF8C00"><strong>&nbsp;POST&nbsp;</strong></font>

**Service URL**

`<%= config[:domain] %>/<%= config[:application] %>/api/<%= config[:version] %>/Token`

**Headers**

Key | Value
--- | -----
<%= config[:contenttype] %> | <%= config[:contenttypeapplicationxwwwformurlencoded] %>

**Body Parameters**

Body Type: <%= config[:bodytypexwwwformurlencoded] %>

Parameter | Value | Description
--------- | ------- | -----------
`grant_type` | password | NA
`username` | someusername | Enter the username of the respective user
`password` | somepassword | Enter the password of the respective user
`clientKey` | GNB | Enter the company code to access respective company details

**POSTMAN Reference Screenshot**

<%= image_tag "images/prerequisite-api_oauth2-token-generation-api_postman-screenshot.png" %>

[comment]: # (#######################################################################################################)
[comment]: # (# 										                      JobStatus API												                      #)
[comment]: # (#######################################################################################################)

## JobStatus API

> If `"status"` value is `"P"` it means **`"Pending"`** and the record processing is under progress. The above command will return a JSON structure like this.

```json
{
  "status": "P",
  "jobID": "0b0b5828-a074-4c78-a73c-9b58bb7169e9"
}
```

> If `"status"` value is `"T"` it means **`"Terminated"`** and `"errorcode"` value is `"Err001"` it means **`"Critical Error"`** while processing records. The above command will return a JSON structure like this.

```json
{
  "status": "T",
  "jobID": "0b0b5828-a074-4c78-a73c-9b58bb7169e9",
  "errorcode": "Err004",
  "info": "Unexpected character encountered while parsing value:"
}
```

> If `"status"` value is `"CE"` it means **`"Completed with Errors"`** and `"errorcode"` value is `"Err002"` it means **`"Some records could not be completed due to errors"`** while processing records. The above command will return a JSON structure like this.

```json
{
  "status": "CE",
  "jobID": "0b0b5828-a074-4c78-a73c-9b58bb7169e9",
  "errorcode": "Err002",
  "details": [
    {
      "_serialnumber": 5,
      "errorcode": "Err101",
      "errorfield": "employeecode"
    },
    {
      "_serialnumber": 5,
      "errorcode": "Err101",
      "errorfield": "fname"
    }
  ]
}
```

> If `"status"` value is `"C"` it means **`"Successfully Completed"`**. The above command will return a JSON structure like this.

```json
{
  "status": "C",
  "jobID": "0b0b5828-a074-4c78-a73c-9b58bb7169e9"
}
```

**Description**

The user needs two codes here `access_token` and `jobID` to retrieve the response generated against the respective job status. 

**HTTP Request Type** 

<font color="#FFFFFF" style="background-color: #2E8B57"><strong>&nbsp;GET&nbsp;</strong></font>

**Service URL**

`<%= config[:domain] %>/<%= config[:application] %>/api/<%= config[:version] %>/JobStatus`

**Headers**

Key | Value | Description
--- | ----- | -----------
<%= config[:contenttype] %> | <%= config[:contenttypeapplicationxwwwformurlencoded] %> | NA
`access_token` | Bearer `xO277wh3fMNPf6e0_qAkOlTJrDNdAD0c-nJfqHiwl3-s8s9K8gjxRKUtvQ3hk8n3Ug9WWYRRcDO5uJKm0rFvJH_oAVQ094O8QH5UfBMDFJ590OoQK0aaxQoTHYbJU1XPNsteFM3RZGZL9ZnG_fNbkpc1A-ahWCScowbR0Z6zjxVrmneLFdh6cfhgiLtatTpmRzbCg5jqMS-NyALE9lI5_Q` | Enter the `access_token` of the respective user

**Query Parameters**

Parameter | Value | Description
--------- | ------- | -----------
`jobID` | `0b0b5828-a074-4c78-a73c-9b58bb7169e9` | Retrieves the result of Job generated

**POSTMAN Reference Screenshot**

<%= image_tag "images/prerequisite-api_job-status-api_postman-screenshot.png" %>